function MapPunch(infile,outfile,emin,emax,nmin,nmax)
%MapPunch.m
%script that punches a hole in the dem file and write a new .xyz
%without coordinates in the specified hole
%
% infile=string containing name of input file, ex: 'terrain.xyz'
% outfile=string containg name of output file, ex: 'holeterrain.xyz'
% emin,emax,nmin,nmax=UTM eastings and northings for boundaries of area to
%  be punched out
%
%
%-----------------------------------------------------------------------------
%Code written by Patricia MacQueen (pmacquee@gmail.com), December 6, 2013.
%If you use this code, please credit me appropriately.
%-----------------------------------------------------------------------------


terrainwhole=load(infile,'-ascii');%load inital xyz file
squid=fopen(outfile,'w+');%create the output file
%preallocate the variable containing the coordinates inside the hole
holyterrain=zeros(size(terrainwhole));
%go through the xyz file and find the coordinates inside the hole
for i=1:length(terrainwhole)
    if (terrainwhole(i,1)<=emax)&&(terrainwhole(i,1)>=emin)&&(terrainwhole(i,2)<=nmax)&&(terrainwhole(i,2)>=nmin&&terrainwhole(i,3)~=0)
          holyterrain(i,1:3)=nan; %turn coordinates in the hole into nans          
    else
        holyterrain(i,1:3)=terrainwhole(i,1:3); %if coordinates are not in the hole, don't turn them into nans       
    end
end

%print only the coordinates that are not nans to the new file
for j=1:length(holyterrain)
if (isfinite(holyterrain(j,1))&&holyterrain(j,3)~=0)
    fprintf(squid,'%.1f %.1f %.1f\r\n',holyterrain(j,1),holyterrain(j,2),holyterrain(j,3));
end
end
fclose(squid);